(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('@tensorflow/tfjs')) :
    typeof define === 'function' && define.amd ? define(['exports', 'react', '@tensorflow/tfjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.ReactTensorflow = {}, global.React, global.tf));
}(this, (function (exports, React, tf) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    var loadModel = function (url, opts) {
        if (url === void 0) { url = ''; }
        if (opts === void 0) { opts = { layers: false }; }
        return __awaiter(void 0, void 0, void 0, function () {
            var layers, _a, isUrlAccepted, isUrlFromTFHub, graphModel, layerModel, err_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        layers = opts.layers;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 7, , 8]);
                        _a = testUrlForAcceptance(url), isUrlAccepted = _a[0], isUrlFromTFHub = _a[1];
                        if (!(isUrlAccepted && !layers)) return [3, 3];
                        return [4, tf.loadGraphModel(url, {
                                fromTFHub: isUrlFromTFHub
                            })];
                    case 2:
                        graphModel = _b.sent();
                        return [2, graphModel];
                    case 3:
                        if (!(isUrlAccepted && layers)) return [3, 5];
                        return [4, tf.loadLayersModel(url)];
                    case 4:
                        layerModel = _b.sent();
                        return [2, layerModel];
                    case 5: throw new Error('Failed to pass a url using a valid scheme - https://www.tensorflow.org/js/guide/save_load#loading_a_tfmodel');
                    case 6: return [3, 8];
                    case 7:
                        err_1 = _b.sent();
                        console.error(err_1);
                        return [2, null];
                    case 8: return [2];
                }
            });
        });
    };
    var testUrlForAcceptance = function (url) {
        var acceptedFilePrefixes = [
            /localstorage:\/\//,
            /indexeddb:\/\//,
            /http:\/\//,
            /https:\/\//,
            /file:\/\//
        ];
        var fileTypeRegex = /\.json/;
        var isUrlFromTFHub = /tfhub\.dev/.test(url);
        var isUrlAccepted = false;
        if (isUrlFromTFHub) {
            isUrlAccepted = acceptedFilePrefixes.some(function (rex) { return rex.test(url); });
        }
        else {
            isUrlAccepted =
                acceptedFilePrefixes.some(function (rex) { return rex.test(url); }) && fileTypeRegex.test(url);
        }
        return [isUrlAccepted, isUrlFromTFHub];
    };

    function useModel(url, opts) {
        var _this = this;
        var _a = React.useState(null), model = _a[0], setModel = _a[1];
        React.useEffect(function () {
            var getModel = function () { return __awaiter(_this, void 0, void 0, function () {
                var loadedModel;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, loadModel(url, opts)];
                        case 1:
                            loadedModel = _a.sent();
                            if (loadedModel) {
                                setModel(loadedModel);
                            }
                            return [2];
                    }
                });
            }); };
            if (url) {
                getModel();
            }
        }, [url]);
        return model;
    }

    var ModelCtx = React.createContext(null);
    ModelCtx.displayName = 'TensorflowModel';
    function ModelProvider(_a) {
        var children = _a.children, url = _a.url, _b = _a.layerModel, layerModel = _b === void 0 ? false : _b;
        var model = useModel(url, { layers: layerModel });
        return React.createElement(ModelCtx.Provider, { value: model }, children);
    }

    var withModel = function (Component) {
        var ComponentWithModel = function (props) { return (React.createElement(ModelCtx.Consumer, null, function (model) { return React.createElement(Component, __assign({}, props, { model: model })); })); };
        ComponentWithModel.displayName = "withModel(" + (Component.displayName ||
            Component.name ||
            'Component') + ")";
        return ComponentWithModel;
    };

    exports.ModelProvider = ModelProvider;
    exports.useModel = useModel;
    exports.withModel = withModel;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
